<?php if (!defined('ABSPATH')) {exit;}
/*
* @since 1.0.0
*
* @param string $url (require)
* @param string $whot (not require)
*
* @return string/false
* Возвращает URL без get-параметров или возвращаем только get-параметры
*/	
function ipytw_deleteGET($url, $whot = 'url') {
	$url = str_replace("&amp;", "&", $url); // Заменяем сущности на амперсанд, если требуется
	list($url_part, $get_part) = array_pad(explode("?", $url), 2, ""); // Разбиваем URL на 2 части: до знака ? и после
	if ($whot == 'url') {
		return $url_part; // Возвращаем URL без get-параметров (до знака вопроса)
	} else if ($whot == 'get') {
		return $get_part; // Возвращаем get-параметры (без знака вопроса)
	} else {
		return false;
	}
}
/*
* @since 1.0.0
*
* @return string/null
* Возвращает версию Woocommerce (string) или (null)
*/ 
function ipytw_get_woo_version_number() {
	// If get_plugins() isn't available, require it
	if (!function_exists('get_plugins')) {
		require_once( ABSPATH . 'wp-admin/includes/plugin.php');
	}
	// Create the plugins folder and file variables
	$plugin_folder = get_plugins('/' . 'woocommerce');
	$plugin_file = 'woocommerce.php';
		
	// If the plugin version number is set, return it 
	if (isset( $plugin_folder[$plugin_file]['Version'] ) ) {
		return $plugin_folder[$plugin_file]['Version'];
	} else {	
		return NULL;
	}
}
/*
* @since 1.0.0
*
* @param string $option_name (require)
* @param string $value (require)
* @param string $n (not require)
* @param string $autoload (not require)
* @param string $type (not require) (@since 1.3.0)
* @param string $source_settings_name (not require) (@since 1.3.0)
*
* @return true/false
* Возвращает то, что может быть результатом add_blog_option, add_option
*/
function ipytw_optionADD($option_name, $value = '', $n = '', $autoload = 'yes', $type = 'option', $source_settings_name = '') {
	if ($option_name == '') {return false;}
	switch ($type) {
		case "set_arr":
			if ($option_name === 'ipytw_status_sborki' || $option_name === 'ipytw_last_element') {if ($n === '0' || $n === 0) {$n = '';}}
			$ipytw_settings_arr = ipytw_optionGET('ipytw_settings_arr');
			$ipytw_settings_arr[$n][$option_name] = $value;
			if (is_multisite()) { 
				return update_blog_option(get_current_blog_id(), 'ipytw_settings_arr', $ipytw_settings_arr);
			} else {
				return update_option('ipytw_settings_arr', $ipytw_settings_arr, $autoload);
			}
		break;
		case "custom_set_arr":
			if ($source_settings_name === '') {return false;}
			if ($n === '0' || $n === 0) {$n = '';}
			$ipytw_settings_arr = ipytw_optionGET($source_settings_name);
			$ipytw_settings_arr[$n][$option_name] = $value;
			if (is_multisite()) { 
				return update_blog_option(get_current_blog_id(), $source_settings_name, $ipytw_settings_arr);
			} else {
				return update_option($source_settings_name, $ipytw_settings_arr, $autoload);
			}
		break;
		default:
			if ($n === '0' || $n === 0) {$n = '';}
			$option_name = $option_name.$n;
			if (is_multisite()) { 
				return add_blog_option(get_current_blog_id(), $option_name, $value);
			} else {
				return add_option($option_name, $value, '', $autoload);
			}
	}
}
/*
* @since 1.0.0
*
* @param string $option_name (require)
* @param string $value (require)
* @param string $n (not require)
* @param string $autoload (not require)
* @param string $type (not require) (@since 1.3.0)
* @param string $source_settings_name (not require) (@since 1.3.0)
*
* @return true/false
* Возвращает то, что может быть результатом update_blog_option, update_option
*/
function ipytw_optionUPD($option_name, $value = '', $n = '', $autoload = 'yes', $type = '', $source_settings_name = '') {
	if ($option_name == '') {return false;}
	switch ($type) {
		case "set_arr": 
			if ($option_name === 'ipytw_status_sborki' || $option_name === 'ipytw_last_element') {if ($n === '0' || $n === 0) {$n = '';}}
			$ipytw_settings_arr = ipytw_optionGET('ipytw_settings_arr');
			$ipytw_settings_arr[$n][$option_name] = $value;
			if (is_multisite()) { 
				return update_blog_option(get_current_blog_id(), 'ipytw_settings_arr', $ipytw_settings_arr);
			} else {
				return update_option('ipytw_settings_arr', $ipytw_settings_arr, $autoload);
			}
		break;
		case "custom_set_arr": 
			if ($source_settings_name === '') {return false;}
			if ($n === '0' || $n === 0) {$n = '';}
			$ipytw_settings_arr = ipytw_optionGET($source_settings_name);
			$ipytw_settings_arr[$n][$option_name] = $value;
			if (is_multisite()) { 
				return update_blog_option(get_current_blog_id(), $source_settings_name, $ipytw_settings_arr);
			} else {
				return update_option($source_settings_name, $ipytw_settings_arr, $autoload);
			}
		break;
		default:
			if ($n === '0' || $n === 0) {$n = '';}
			$option_name = $option_name.$n;
			if (is_multisite()) { 
				return update_blog_option(get_current_blog_id(), $option_name, $value);
			} else {
				return update_option($option_name, $value, $autoload);
			}
	}
}
/*
* @since 1.0.0
*
* @param string $optName (require)
* @param string $n (not require)
* @param string $type (not require) (@since 1.3.0)
* @param string $source_settings_name (not require) (@since 1.3.0)
*
* @return Значение опции (string/array) или false
* Возвращает то, что может быть результатом get_blog_option, get_option
*/
function ipytw_optionGET($option_name, $n = '', $type = '', $source_settings_name = '') {
	if ($option_name == '') {return false;}	
	switch ($type) {
		case "set_arr": 
			if ($option_name === 'ipytw_status_sborki' || $option_name === 'ipytw_last_element') {if ($n === '0' || $n === 0) {$n = '';}}
			$ipytw_settings_arr = ipytw_optionGET('ipytw_settings_arr');
			if (isset($ipytw_settings_arr[$n][$option_name])) {
				return $ipytw_settings_arr[$n][$option_name];
			} else {
				return false;
			}
		break;
		case "custom_set_arr":
			if ($source_settings_name === '') {return false;}
			if ($n === '0' || $n === 0) {$n = '';}
			$ipytw_settings_arr = ipytw_optionGET($source_settings_name);
			if (isset($ipytw_settings_arr[$n][$option_name])) {
				return $ipytw_settings_arr[$n][$option_name];
			} else {
				return false;
			}
		break;
		case "for_update_option":
			if ($n === '0' || $n === 0) {$n = '';}
			$option_name = $option_name.$n;
			if (is_multisite()) { 
				return get_blog_option(get_current_blog_id(), $option_name);
			} else {
				return get_option($option_name);
			}		
		break;
		default:
			if ($n === '0' || $n === 0) {$n = '';}
			$option_name = $option_name.$n;
			if (is_multisite()) { 
				return get_blog_option(get_current_blog_id(), $option_name);
			} else {
				return get_option($option_name);
			}
	}
}
/*
* С версии 1.0.0
*
* @param string $option_name (require)
* @param string $n (not require)
* @param string $type (not require) (@since 1.3.0)
* @param string $source_settings_name (not require) (@since 1.3.0)
*
* @return true/false
* Возвращает то, что может быть результатом delete_blog_option, delete_option
*/
function ipytw_optionDEL($option_name, $n = '', $type = '', $source_settings_name = '') {
	if ($option_name == '') {return false;}	 
	switch ($type) {
		case "set_arr": 
			if ($option_name === 'ipytw_status_sborki' || $option_name === 'ipytw_last_element') {if ($n === '0' || $n === 0) {$n = '';}}
			$ipytw_settings_arr = ipytw_optionGET('ipytw_settings_arr');
			unset($ipytw_settings_arr[$n][$option_name]);
			if (is_multisite()) { 
				return update_blog_option(get_current_blog_id(), 'ipytw_settings_arr', $ipytw_settings_arr);
			} else {
				return update_option('ipytw_settings_arr', $ipytw_settings_arr);
			}
		break;
		case "custom_set_arr": 
			if ($source_settings_name === '') {return false;}
			if ($n === '0' || $n === 0) {$n = '';}
			$ipytw_settings_arr = ipytw_optionGET($source_settings_name);
			unset($ipytw_settings_arr[$n][$option_name]);
			if (is_multisite()) { 
				return update_blog_option(get_current_blog_id(), $source_settings_name, $ipytw_settings_arr);
			} else {
				return update_option($source_settings_name, $ipytw_settings_arr);
			}
		break;
		default:
		if ($n === '0' || $n === 0) {$n = '';}
		$option_name = $option_name.$n;
		if (is_multisite()) { 
			return delete_blog_option(get_current_blog_id(), $option_name);
		} else {
			return delete_option($option_name);
		}
	}
}
/*
* @since 1.0.0
*
* @param string $name_dir (require)
*
* @return true/false
* Проверяет наличие и при необходимости создаёт папку кэша плагина
*/
function ipytw_check_dir($name_dir) {
	if (!is_dir($name_dir)) {
		if (!mkdir($name_dir)) {
			error_log('ERROR: Нет папки '.$name_dir.'! И создать не вышло! $name_dir ='.$name_dir.'; Файл: functions.php; Строка: '.__LINE__, 0);
			return false;
		} else {
			error_log('ERROR: Создали папку '.$name_dir.'! Файл: functions.php; Строка: '.__LINE__, 0);
			return true;
		}
	} return true;
}
/*
* @since 1.0.0
*
* @param string $url (require)
*
* @return nothing
* Записывает текст ошибки, чтобы потом можно было отправить в отчет
*/
function ipytw_errors_log($message) {
	$message = '['.date('Y-m-d H:i:s').'] '. $message;
	if (is_multisite()) {
		update_blog_option(get_current_blog_id(), 'ipytw_errors', $message);
	} else {
		update_option('ipytw_errors', $message, '', 'no');
	}
}
/*
* @since 1.0.0
*
* @param string $text (require)
*
* @return nothing
* Записывает файл логов /wp-content/uploads/import-from-yml/ipytw.log
*/
function ipytw_error_log($text) {	
	if (ipytw_KEEPLOGS !== 'on') {return;}
	$upload_dir = (object)wp_get_upload_dir();
	$name_dir = $upload_dir->basedir."/import-from-yml";
	// подготовим массив для записи в файл логов
	if (is_array($text)) {$r = ipytw_array_to_log($text); unset($text); $text = $r;}
	if (is_dir($name_dir)) {
		$filename = $name_dir.'/ipytw.log';
		file_put_contents($filename, '['.date('Y-m-d H:i:s').'] '.$text.PHP_EOL, FILE_APPEND);		
	} else {
		if (!mkdir($name_dir)) {
			error_log('Нет папки import-from-yml! И создать не вышло! $name_dir ='.$name_dir.'; Файл: functions.php; Строка: '.__LINE__, 0);
		} else {
			error_log('Создали папку ipytw!; Файл: functions.php; Строка: '.__LINE__, 0);
			$filename = $name_dir.'/ipytw.log';
			file_put_contents($filename, '['.date('Y-m-d H:i:s').'] '.$text.PHP_EOL, FILE_APPEND);
		}
	} 
	return;
}
/*
* @since 1.0.0
*
* @param string $text (require)
* @param int $i (not require)
* @param string $res (not require)
*
* @return formatted string
* Позволяте писать в логи массив /wp-content/uploads/import-from-yml/ipytw.log
*/
function ipytw_array_to_log($text, $i=0, $res = '') {
	$tab = ''; for ($x = 0; $x<$i; $x++) {$tab = '---'.$tab;}
	if (is_array($text)) { 
	$i++;
	foreach ($text as $key => $value) {
		if (is_array($value)) {	// массив
			$res .= PHP_EOL .$tab."[$key] => ";
			$res .= $tab.ipytw_array_to_log($value, $i);
		} else { // не массив
			$res .= PHP_EOL .$tab."[$key] => ". $value;
		}
	}
	} else {
		$res .= PHP_EOL .$tab.$text;
	}
	return $res;
}
/*
* @since 1.0.0
*
* @return array
* Возвращает список потенциальных проблем
*/
function ipytw_possible_problems_list() {
	$possibleProblems = ''; $possibleProblemsCount = 0; $conflictWithPlugins = 0; $conflictWithPluginsList = ''; 
	$check_global_attr_count = wc_get_attribute_taxonomies();
	if (count($check_global_attr_count) < 1) {
		$possibleProblemsCount++;
		$possibleProblems .= '<li>'. __('Your site has no global attributes! This may affect the quality of the YML feed. This can also cause difficulties when setting up the plugin', 'ipytw'). '. <a href="https://icopydoc.ru/globalnyj-i-lokalnyj-atributy-v-woocommerce/?utm_source=yml-for-yandex-market&utm_medium=organic&utm_campaign=in-plugin-yml-for-yandex-market&utm_content=debug-page&utm_term=possible-problems">'. __('Please read the recommendations', 'ipytw'). '</a>.</li>';
	}
	if (is_plugin_active('snow-storm/snow-storm.php')) {
		$possibleProblemsCount++;
		$conflictWithPlugins++;
		$conflictWithPluginsList .= 'Snow Storm<br/>';
	}
	if (is_plugin_active('email-subscribers/email-subscribers.php')) {
		$possibleProblemsCount++;
		$conflictWithPlugins++;
		$conflictWithPluginsList .= 'Email Subscribers & Newsletters<br/>';
	}
	if (is_plugin_active('saphali-search-castom-filds/saphali-search-castom-filds.php')) {
		$possibleProblemsCount++;
		$conflictWithPlugins++;
		$conflictWithPluginsList .= 'Email Subscribers & Newsletters<br/>';
	}
	if (is_plugin_active('w3-total-cache/w3-total-cache.php')) {
		$possibleProblemsCount++;
		$conflictWithPlugins++;
		$conflictWithPluginsList .= 'W3 Total Cache<br/>';
	}
	if (is_plugin_active('docket-cache/docket-cache.php')) {
		$possibleProblemsCount++;
		$conflictWithPlugins++;
		$conflictWithPluginsList .= 'Docket Cache<br/>';
	}					
	if (class_exists('MPSUM_Updates_Manager')) {
		$possibleProblemsCount++;
		$conflictWithPlugins++;
		$conflictWithPluginsList .= 'Easy Updates Manager<br/>';
	}
	if (class_exists('OS_Disable_WordPress_Updates')) {
		$possibleProblemsCount++;
		$conflictWithPlugins++;
		$conflictWithPluginsList .= 'Disable All WordPress Updates<br/>';
	}
	if ($conflictWithPlugins > 0) {
		$possibleProblemsCount++;
		$possibleProblems .= '<li><p>'. __('Most likely, these plugins negatively affect the operation of', 'ipytw'). ' Import products from YML to WooCommerce:</p>'.$conflictWithPluginsList.'<p>'. __('If you are a developer of one of the plugins from the list above, please contact me', 'ipytw').': <a href="mailto:support@icopydoc.ru">support@icopydoc.ru</a>.</p></li>';
	}
	return array($possibleProblems, $possibleProblemsCount, $conflictWithPlugins, $conflictWithPluginsList);
}
/*
* С версии 1.0.0
*
* @param int $feedId (require)
*
* @return array
* Возвращает массив просинхронизированных категорий. Где ключ - id массива в фиде. Значение - id категори у нас на сайте
*/
function ipytw_get_imported_cat($feedId) {
	ipytw_error_log('FEED № '.$feedId.'; Стартовала ipytw_get_imported_cat; Файл: functions.php; Строка: '.__LINE__, 0);

	$upload_dir = (object)wp_get_upload_dir();
	$name_dir = $upload_dir->basedir.'/import-from-yml';
	ipytw_check_dir($name_dir);

	$filename = $name_dir.'/feed-importetd-cat-ids-'.$feedId.'.tmp';

	if (is_file($filename)) {
		$result_arr = file_get_contents($filename);
		return unserialize($result_arr);
	} else { // Файла нет
		ipytw_error_log('FEED № '.$feedId.'; ERROR: Нет файла: '.$filename.'; Файл: functions.php; Строка: '.__LINE__, 0);
		return array();
	}
} // end function ipytw_get_imported_cat()
/*
* @since 1.0.0
*
* @param string $meta_value (require)
* @param int $feedId (require) - @since 1.1.0
* @param string $meta_key (not require)
* @param string $post_type (not require)
* @param bool $product_sku (not require) - @since 1.2.2
*
* @return int/false
* Проверяет, синхронили ли мы товар/картинку
*/
function ipytw_check_sync($meta_value, $feedId, $post_type = 'attachment', $meta_key = '_ipytw_import_feed_picture_url', $product_sku = false) {
	if ($post_type === 'product') {
		$meta_key = '_ipytw_feed_product_id'; 
		$args = array(
			'post_type' => $post_type,
			'fields' => 'ids',
			'relation' => 'AND',
			'meta_query' => array(
				'relation' => 'AND',
				array(
					'key' => $meta_key,
					'value' => $meta_value,
				),
				array(
					'key' => '_ipytw_feed_id',
					'value' => $feedId,
				),
			),
		);
	} else {
		$args = array(
			'post_type' => $post_type,
			'fields' => 'ids',
			'relation' => 'AND',
			'meta_query' => array(
				array(
					'key' => $meta_key,
					'value' => $meta_value,
				),
			),
		);
	}
	if ($ids = get_posts($args)) {
		$result = array_pop($ids);
	} else {
		$result = false;
		/* if ($product_sku === false) {
			$result = false;
		} else {
			if ($post_type === 'product') {
				$isset_product_id = wc_get_product_id_by_sku($product_sku);
				if ($isset_product_id > 0) {
					$result = $isset_product_id;
					ipytw_error_log('NOTICE: Артикул '.$product_sku.' обнаружен у товара с $isset_product_id = '.$isset_product_id.'; Файл: function.php; Строка: '.__LINE__, 0);				
				} else {
					$result = false;
				}
			} else {
				$result = false;
			}
		} */
	}
	return $result;
}
/*
* @since 1.0.0
*
* @return nothing
* Обновляет настройки плагина
*/
function ipytw_set_new_options() {
	wp_clean_plugins_cache();
	wp_clean_update_cache();
	add_filter('pre_site_transient_update_plugins', '__return_null');
	wp_update_plugins();
	remove_filter('pre_site_transient_update_plugins', '__return_null');

	$ipytw_version = ipytw_optionGET('ipytw_version');		
	if (version_compare($ipytw_version, '1.3.0', '<')) { // версия плагина ниже 1.3.0
		$ipytw_settings_arr = ipytw_optionGET('ipytw_settings_arr');
		$ipytw_settings_arr_keys_arr = array_keys($ipytw_settings_arr);
		for ($i = 0; $i<count($ipytw_settings_arr_keys_arr); $i++) {
			$key = $ipytw_settings_arr_keys_arr[$i];
			if (isset($ipytw_settings_arr[$key])) {
				$newkey = (string)$key; // преобразовываем ключ массива из числовго в строковый
				$ipytw_settings_arr_keys_arr[$newkey] = $ipytw_settings_arr_keys_arr[$i];
				unset($ipytw_settings_arr_keys_arr[$i]); // удаляем числовой ключ
				$feedId = $key;
				wp_clear_scheduled_hook('ipytw_cron_period', array($feedId)); // отключаем крон
				wp_clear_scheduled_hook('ipytw_cron_sborki', array($feedId)); // отключаем крон

				$ipytw_status_sborki_key = 'ipytw_status_sborki'.$key;
				$ipytw_last_element_key = 'ipytw_last_element'.$key;
				ipytw_optionDEL($ipytw_status_sborki_key, $key);
				ipytw_optionDEL($ipytw_last_element_key, $key);
				ipytw_optionADD($ipytw_status_sborki_key, '-1');
				ipytw_optionADD($ipytw_last_element_key, '-1');
			}
		}
		ipytw_optionUPD('ipytw_settings_arr', $ipytw_settings_arr);

		$ipytw_registered_feeds_arr = ipytw_optionGET('ipytw_registered_feeds_arr');
		for ($i = 1; $i < count($ipytw_registered_feeds_arr); $i++) { // с единицы, т.к инфа по конкретным фидам там
			$feedId = $ipytw_registered_feeds_arr[$i]['id'];
			$ipytw_registered_feeds_arr[$i]['id'] = (string)$feedId;
		}	
		ipytw_optionUPD('ipytw_registered_feeds_arr', $ipytw_registered_feeds_arr);
	}

	$ipytw_settings_arr = ipytw_optionGET('ipytw_settings_arr'); // получаем настройки
	$ipytw_registered_feeds_arr = ipytw_optionGET('ipytw_registered_feeds_arr');
	for ($i = 1; $i < count($ipytw_registered_feeds_arr); $i++) { // с единицы, т.к инфа по конкретным фидам там
		$feedId = $ipytw_registered_feeds_arr[$i]['id'];
		if (!isset($ipytw_settings_arr[$feedId]['ipytw_source_sku'])) {$ipytw_settings_arr[$feedId]['ipytw_source_sku'] = 'disabled';}
		if (!isset($ipytw_settings_arr[$feedId]['ipytw_product_was_sync'])) {$ipytw_settings_arr[$feedId]['ipytw_product_was_sync'] = 'price_only';}
		if (!isset($ipytw_settings_arr[$feedId]['ipytw_post_status'])) {$ipytw_settings_arr[$feedId]['ipytw_post_status'] = 'publish';}
		if (!isset($ipytw_settings_arr[$feedId]['ipytw_fsize_limit'])) {$ipytw_settings_arr[$feedId]['ipytw_fsize_limit'] = 5;}
		if (!isset($ipytw_settings_arr[$feedId]['ipytw_if_isset_sku'])) {$ipytw_settings_arr[$feedId]['ipytw_if_isset_sku'] = 'update';}	
	}
	ipytw_optionUPD('ipytw_settings_arr', $ipytw_settings_arr); // обновляем

	if (defined('ipytw_VER')) {
		if (is_multisite()) {
			update_blog_option(get_current_blog_id(), 'ipytw_version', ipytw_VER);
		} else {
			update_option('ipytw_version', ipytw_VER);
		}
	}
}
/*
* @since 1.1.0
*
* @return array
* Возвращает массив настроек фида по умолчанию
*/
function ipytw_set_default_feed_settings_arr($whot = 'feed') {
	if ($whot === 'feed') {
		$result_arr = array(
			'ipytw_status_cron' => 'off',
			'ipytw_date_sborki' => -1,
			'ipytw_date_save_set' => -1,
			'ipytw_count_elements' => -1,
			'ipytw_run_cron' => 'off',
			'ipytw_feed_assignment' => '',
			'ipytw_url_yml_file' => '',
			'ipytw_when_import_category' => 'always',
			'ipytw_product_was_sync' => 'price_only',
			'ipytw_post_status' => 'publish',
			'ipytw_step_import' => 25,
			'ipytw_source_sku' => 'disabled',
			'ipytw_if_isset_sku' => 'update',
			'ipytw_fsize_limit' => 5,
			'ipytw_count_offers' => 0
		);
	} 
	$result_arr = apply_filters('ipytw_set_default_feed_settings_result_arr_filter', $result_arr, $whot);
	return $result_arr;
}
/*
* @since 1.1.1
*
* @param string $name (require)
*
* @return int/false
* Проверяет, существует ли в системе глобальный атрибут. Если не существует - создаёт
* https://stackoverflow.com/questions/29549525/create-new-product-attribute-programmatically-in-woocommerce/51994543#51994543
* https://stackoverflow.com/questions/58942156/woocommerce-programmatically-add-product-attributes-and-their-corresponding-valu
*/
function ipytw_create_product_attribute($attribute_name) {
	// $singular_name - для наглядности ибо get_taxonomy() 
	// ["name"] => string(24) "pa_второй-тест" 
	// ["singular_name"] => string(21) "Второй тест" 
	ipytw_error_log('INFO: Стартавала ipytw_create_product_attribute. $attribute_name = '.$attribute_name.'; Файл: function.php; Строка: '.__LINE__, 0);
	if (function_exists('wc_get_attribute_taxonomies')) {
		$attribute_taxonomies = wc_get_attribute_taxonomies();
	} else {
		global $woocommerce; $attribute_taxonomies = $woocommerce->get_attribute_taxonomies();
	}
	$attribute_id = 0;
	if (count($attribute_taxonomies) > 0) {
		foreach($attribute_taxonomies as $one_tax ) {
			/**
			* $one_tax->attribute_id => 6
			* $one_tax->attribute_name] => слаг (на инглише или русском)
			* $one_tax->attribute_label] => Еще один атрибут (это как раз название)
			* $one_tax->attribute_type] => select 
			* $one_tax->attribute_orderby] => menu_order
			* $one_tax->attribute_public] => 0			
			*/
			if ($one_tax->attribute_label == $attribute_name) {
				$attribute_id = (int)$one_tax->attribute_id;
				$taxonomy_name = $one_tax->attribute_name; 
				ipytw_error_log('Есть глобальный атрибут "'.$attribute_name.'" с $taxonomy_name = '.$taxonomy_name.', $attribute_id = '.$attribute_id.'; Файл: function.php; Строка: '.__LINE__, 0);
				break;
			}
		}
	}
	if ($attribute_id === 0) {
		ipytw_error_log('Нет глобального атрибута $attribute_name = '.$attribute_name.'; Файл: function.php; Строка: '.__LINE__, 0);
	} else {
		ipytw_error_log('INFO: Перед return1; $attribute_id = '.$attribute_id.' gettype('.gettype($attribute_id).'); Файл: function.php; Строка: '.__LINE__, 0);
		return $attribute_id;
	}

	$slug = wc_sanitize_taxonomy_name($attribute_name); // приводим к виду второй-тест
	if (strlen($slug) >= 28) {$slug = ipytw_strlen_slug($slug);} 

	if (wc_check_if_attribute_name_is_reserved($slug)) {
		ipytw_error_log('ERROR: Ошибка создания атрибута. Название таксономии $slug = '.$slug.' зарезервировано; Файл: function.php; Строка: '.__LINE__, 0);
		return false;
	}

	$attribute_id = wc_create_attribute(array(
		'name'			=> $attribute_name,
		'slug'			=> $slug,
		'type'			=> 'select',
		'order_by'		=> 'menu_order',
		'has_archives'	=> false, // Enable archives ==> true
	));

	if (is_wp_error($attribute_id)) {
		$error_message = $attribute_id->get_error_message();
		$error_code = $attribute_id->get_error_code();
		ipytw_error_log('ERROR: Ошибка создания атрибута $attribute_name = '.$attribute_name.'; $error_message = '.$error_message.'; $error_code = '.$error_code.'; Файл: function.php; Строка: '.__LINE__, 0);
		return false;
	} else {
		ipytw_error_log('INFO: Глобальный атрибут '.$attribute_name.'; $attribute_id = '.$attribute_id.' успешно создан; Файл: function.php; Строка: '.__LINE__, 0);
	}

	// Register it as a wordpress taxonomy for just this session. Later on this will be loaded from the woocommerce taxonomy table.
	register_taxonomy(
		$slug,
		apply_filters('woocommerce_taxonomy_objects_' . $slug, array('product')),
		apply_filters('woocommerce_taxonomy_args_' . $slug, array(
			'labels' => array('name' => $attribute_name,),
			'hierarchical'	=> true,
			'show_ui'		=> false,
			'query_var'		=> true,
			'rewrite'		=> false,
		))
	);

	// do_action('woocommerce_attribute_added', $id, $data);
	wp_schedule_single_event( time(), 'woocommerce_flush_rewrite_rules');
	delete_transient('wc_attribute_taxonomies'); // Clear caches

	ipytw_error_log('INFO: Перед return2; $attribute_id = '.$attribute_id.' gettype('.gettype($attribute_id).'); Файл: function.php; Строка: '.__LINE__, 0);
	return $attribute_id;
}
/*
* @since 1.1.1
*
* @param string $attribute_value (require)
* @param int $attribute_id (not require)
* @param string $attribute_taxonomy (not require)
*
* @return array(2) (["id"]=> int ["slug"]=> string) / array(2) (["id"]=> false ["slug"]=> false)
* Проверяет, существует ли значение у данного глобального атрибута. Если не существует - создаёт
* https://stackoverflow.com/questions/29549525/create-new-product-attribute-programmatically-in-woocommerce/51994543#51994543
* https://stackoverflow.com/questions/58942156/woocommerce-programmatically-add-product-attributes-and-their-corresponding-valu
*/
function ipytw_create_attribute_term($attribute_value, $attribute_id = 0 /*, $attribute_taxonomy = ''*/) {
	if ($attribute_id === 0) {return array('id' => false, 'slug' => false);}
	$attribute_id = (int)$attribute_id;

	$attribute_taxonomy_name = wc_attribute_taxonomy_name_by_id($attribute_id);

	// Look if there is already a term for this attribute?
	$term = get_term_by('name', $attribute_value, $attribute_taxonomy_name);

	if (!$term) { //No, create new term.
		$term = wp_insert_term($attribute_value, $attribute_taxonomy_name);
		if (is_wp_error($term))	{
			ipytw_error_log('ERROR: Невозможно создать новый термин атрибута $attribute_value = '.$attribute_value.' таксономии $attribute_taxonomy_name = '.$attribute_taxonomy_name.'; Файл: function.php; Строка: '.__LINE__, 0);
			$error_message = $term->get_error_message();
			$error_code = $term->get_error_code();
			ipytw_error_log('ERROR: Ошибка создания термина атрибута $attribute_value = '.$attribute_value.'; $error_message = '.$error_message.'; $error_code = '.$error_code.'; Файл: function.php; Строка: '.__LINE__, 0);
			return array('id' => false, 'slug' => false);
		}
		$termId = $term['term_id'];
		$term_slug = get_term($termId, $attribute_taxonomy_name)->slug; // Get the term slug
	} else {
		// Yes, grab it's id and slug
		$termId = $term->term_id;
		$term_slug = $term->slug;
	}
	return array('id' => $termId, 'slug' => $term_slug);
}
/*
* @since 1.1.1
*
* @param string $attributes (require) ($attributes = $product->get_attributes();)
* @param string $attribute_name (require)
*
* @return true/false
* Проверяет, существует ли атрибут с таким название у товара
*/
function ipytw_has_attribute($attributes, $attribute_name) {
	foreach ($attributes as $param) {					
		$param_name = wc_attribute_label(wc_attribute_taxonomy_name_by_id($param->get_id()));
		if ($param_name == $attribute_name) { 
			return true;
		}
	}
	return false;
}
/*
* @since 1.2.0
*
* @param string $path (require)
* @param string $unit (not require)
* @param int $round (not require)
* @param string $show_unit (not require)
* @param string $dec_point (not require)
* @param string $thousands_sep (not require)
*
* @return int/null
* Возвращает размер файла на удалённом сервере
* https://yandex.ru/turbo/internet-technologies.ru/s/articles/opredelenie-razmera-udalennogo-fayla.html
*/
function ipytw_fsize($path, $unit = 'B', $show_unit = 'no', $round = 2, $dec_point = '', $thousands_sep = '') {
	$result = null;
	if (empty($path)) {return $result;}
	$fp = fopen($path, "r");
	$inf = stream_get_meta_data($fp);
	fclose($fp);
	foreach ($inf["wrapper_data"] as $v) {
		if (stristr($v, "content-length")) {
			$v = explode(":", $v);
			$result = trim($v[1]);
			switch ($unit) {
				case 'GB': $result = number_format($result / 1073741824, $round, $dec_point, $thousands_sep); break;
				case 'MB': $result = number_format($result / 1048576, $round, $dec_point, $thousands_sep); break;
				case 'KB': $result = number_format($result / 1024, $round, $dec_point, $thousands_sep); break;
				case 'B': $result = number_format($result / 1, $round, $dec_point, $thousands_sep); break;
				default: $result = number_format($result / 1, $round, $dec_point, $thousands_sep);
			}	
			if ($show_unit === 'yes') {$result = $result.' '.$unit;}
			break;
		} 
	}
	return $result;
}
/*
* @since 1.2.2
*
* @param string $sku (require)
*
* @return true/false
* Проверяет, есть ли товар с таким SKU
* https://woocommerce.github.io/code-reference/files/woocommerce-includes-wc-product-functions.html
*/
function ipytw_is_uniq_sku($sku) {
	if ($sku === false || $sku === '') {return false;}
	if (wc_get_product_id_by_sku($sku) > 0) {
		return true;
	} else {
		return false;
	}
}
/*
* @since 1.2.3
*
* @return last key of array
* Eсли версия PHP < 7.3 создаёт функцию array_key_last
*/
if (!function_exists("array_key_last")) {
	function array_key_last($array) {
		if (!is_array($array) || empty($array)) {
			return NULL;
		}
		return array_keys($array)[count($array)-1];
	}
}
/*
* @since 1.2.3
*
* @param string $slug (require)
*
* @return string
*/
function ipytw_strlen_slug($slug) {
	$slug = mb_substr($slug, 0, 27); // 27 символом на слаг
	if (strlen($slug) >= 28) {	// если в итоге байт больше
		for ($i = mb_strlen($slug); $i = 1; $i--) {
			$slug = mb_substr($slug, 0, -1);
			if (strlen($slug) < 28) {break;}
		}
	}
	return $slug;
}
/*
* @since 1.3.0
*
* @return first key of array
* Eсли версия PHP < 7.3 создаёт функцию array_key_first
*/
if (!function_exists('array_key_first')) {
    function array_key_first(array $arr) {
        foreach($arr as $key => $unused) {
            return $key;
        }
        return NULL;
    }
}
/*
* @since 1.3.0
*
* @return (string) feed ID or (string)''
* Получает первый фид. Используется на случай если get-параметр numFeed не указан
*/
function get_first_feed_id() {
	$ipytw_settings_arr = ipytw_optionGET('ipytw_settings_arr');
	if (!empty($ipytw_settings_arr)) {
		return array_key_first($ipytw_settings_arr);
	} else {
		return '';
	}
}
/*
* @since 1.3.0
*
* @param string $url (require)
*
* Вместо file_get_contents используем curl
*/
function ipytw_file_get_contents_curl($url) {
	$ch = curl_init(); // Инициализируем curl

	curl_setopt($ch, CURLOPT_URL, $url ); // Указываем ссылку
	curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE); // подставляем Referer при перенаправлении
	curl_setopt($ch, CURLOPT_HEADER, 0); // Не выводим заголовки
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // Сохраним полученный результат в переменную 
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE); // Идем по перенаправлению 
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // Не проверяем SSL сертификат
	curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0'); // Установим Useragent

	$getData = curl_exec($ch); // Выполняем запрос на сайт
	curl_close($ch); // Закрываем curl

	return $getData; // Возвращаем из функции полученные данные
}
?>