<?php if (!defined('ABSPATH')) {exit;}
include_once ABSPATH . 'wp-admin/includes/plugin.php'; // без этого не будет работать вне адмники is_plugin_active
function ipytw_feed_header($feedId) {
 ipytw_error_log('FEED № '.$feedId.'; Стартовала ipytw_feed_header; Файл: offer.php; Строка: '.__LINE__, 0);
 $unixtime = current_time('Y-m-d H:i'); // время в unix формате 
 ipytw_optionUPD('ipytw_date_sborki', $unixtime, $feedId, 'yes', 'set_arr');
 
 $ipytw_url_yml_file = ipytw_optionGET('ipytw_url_yml_file', $feedId, 'set_arr'); 
 if ($ipytw_url_yml_file == '') {ipytw_error_log('FEED № '.$feedId.'; ERROR: Не указан URL фида: '.$ipytw_url_yml_file.'. Остановим сборку; Файл: offer.php; Строка: '.__LINE__, 0); return false;}
 $ipytw_when_import_category = ipytw_optionGET('ipytw_when_import_category', $feedId, 'set_arr'); 
 if ($ipytw_when_import_category === 'always' || $ipytw_when_import_category === 'once') { 
	ipytw_error_log('FEED № '.$feedId.'; Читаем файл: '.$ipytw_url_yml_file.'; Файл: offer.php; Строка: '.__LINE__, 0);

	$xml_string = ipytw_file_get_contents_curl($ipytw_url_yml_file);
	if ($xml_string === false) { 
		ipytw_error_log('ERROR: ipytw_feed_header: Нет доступа к файлу $ipytw_url_yml_file = '.$ipytw_url_yml_file.'; Файл: offer.php; Строка: '.__LINE__, 0);
		return false;		
	} else {
		$xml_object = new SimpleXMLElement($xml_string);
	}
	
	$xml_categories_object = $xml_object->shop->categories;
	$feed_categories_arr = array(); // данные по всем категориям в фиде
	$feed_exists_cat_id_arr = array(); // id всех существующих категорий в фиде. Нужен для проверки.
	for ($i = 0; $i < count($xml_categories_object->children()); $i++) {
		$category_name = $xml_categories_object->category[$i];
		$xml_category_attr_object = $xml_categories_object->category[$i]->attributes();
	
		$attr_id = $xml_category_attr_object->id;
		$attr_parentId = $xml_category_attr_object->parentId; // если нет атрибута parentId вернёт null
		if ($attr_parentId === null) {$attr_parentId = 0;}
		$feed_categories_arr[] = array(
			'id' => (int)$attr_id,
			'parent_id' => (int)$attr_parentId,
			'name' => (string)$category_name
		);
		$feed_exists_cat_id_arr[] = (int)$attr_id;
	} 

	ipytw_error_log('данные по всем категориям в фиде', 0);
	ipytw_error_log($feed_categories_arr, 0);

	$i = 0; 
	$find_cat_arr = array();
	while (0 < count($feed_categories_arr)) {
		ipytw_error_log('$feed_categories_arr['.$i.'][id] = '.$feed_categories_arr[$i]['id'], 0);
		if ($feed_categories_arr[$i]['parent_id'] == 0) { // это родительская категория
			$category_id = $feed_categories_arr[$i]['id'];
			$attr_parentId = $feed_categories_arr[$i]['parent_id'];
			$category_name = $feed_categories_arr[$i]['name'];	
			$category = term_exists($category_name, 'product_cat');
			if ($category === null) { // таксономии нет. Нужно создать
				ipytw_error_log('Категории нет. Нужно создать. $category_name = '.$category_name.', $attr_parentId = '.$attr_parentId.'; Файл: offer.php; Строка: '.__LINE__, 0);
				$data_arr = array();
				$data_arr['parent'] = $attr_parentId;
				$insert_data = wp_insert_term($category_name, 'product_cat', $data_arr);
				// update_term_meta($term_id, 'yml-importer:id', $id);

				if (!is_wp_error($insert_data)) {
					$find_cat_arr[$feed_categories_arr[$i]['id']] = $insert_data['term_id']; // добавим её id в массив найденных 
				}
			} else { // категория есть. Нужно обновить
				ipytw_error_log('категория есть. Нужно обновить. $category_id = '.$category_id.'; Файл: offer.php; Строка: '.__LINE__, 0);
				$category_id = $category['term_id'];
				$insert_data = wp_update_term($category_id, 'product_cat', array(
					'name' => $category_name,
					'parent' => $attr_parentId
				));	
				
				if (!is_wp_error($insert_data)) {
					$find_cat_arr[$feed_categories_arr[$i]['id']] = $insert_data['term_id']; // добавим её id в массив найденных 
				}
			}
			array_splice($feed_categories_arr, $i, 1); // сократим массив
			$i = 0;
		} else { // это дочерняя категория
			// проверим от глюков в фиде
			if (!in_array($feed_categories_arr[$i]['parent_id'], $feed_exists_cat_id_arr)) {
				ipytw_error_log('NOTICE: В фиде есть ошибка! Родительской категории с id='.$feed_categories_arr[$i]['parent_id'].'. Не существует! Пропустим данную категорию; Файл: offer.php; Строка: '.__LINE__, 0);	
				array_splice($feed_categories_arr, $i, 1);
				$i = 0; continue;
			}

			if (array_key_exists($feed_categories_arr[$i]['parent_id'], $find_cat_arr)) {
				// категория-родитель уже просинхронена. Можно добавить категорию.
				$category_id = $feed_categories_arr[$i]['id'];
				$attr_parentId = $find_cat_arr[$feed_categories_arr[$i]['parent_id']]; // важное различие с 1-м вариантом!
				$category_name = $feed_categories_arr[$i]['name'];	
				$category = term_exists($category_name, 'product_cat');
				if ($category === null) { // таксономии нет. Нужно создать
					$data_arr = array();
					$data_arr['parent'] = $attr_parentId;
					$insert_data = wp_insert_term($category_name, 'product_cat', $data_arr);
					// update_term_meta($term_id, 'yml-importer:id', $id);

					if (!is_wp_error($insert_data)) {
						$find_cat_arr[$feed_categories_arr[$i]['id']] = $insert_data['term_id']; // добавим её id в массив найденных 
					}
				} else { // категория есть. Нужно обновить
					if (is_array($category)) {
						$category_id = $category['term_id'];
						$insert_data = wp_update_term($category_id, 'product_cat', array(
	/* ! */					'name' => $category_name, // иногда даёт ошибку PHP Notice:  Trying to get property 'category_id' of non-object in хз почему
							'parent' => $attr_parentId // error_log('метка 1 $attr_parentId = '.$attr_parentId.' $category_id = '.$category_id.' $category_name = '.$category_name, 0);
						));						
						if (!is_wp_error($insert_data)) {
							$find_cat_arr[$feed_categories_arr[$i]['id']] = $insert_data['term_id']; // добавим её id в массив найденных 
						}
					} else {
						ipytw_error_log('NOTICE: Логируем $category = '.$category.';Файл: offer.php; Строка: '.__LINE__, 0);	
					}
				}
				array_splice($feed_categories_arr, $i, 1); // сократим массив
				$i = 0;
			} else { // категорию-родитель ещё не синхронили. Пока пропустим.
				$i++; continue;
			}
		}
	}

	$upload_dir = (object)wp_get_upload_dir();
	$name_dir = $upload_dir->basedir.'/import-from-yml';
	$res = ipytw_check_dir($name_dir);
	if ($res === false) {
		error_log('ERROR: ipytw_feed_header: Создать папку $name_dir ='.$name_dir.' не вышло; Файл: offer.php; Строка: '.__LINE__, 0);
		return false;
	}

	if (is_dir($name_dir)) {
		$filename = $name_dir.'/feed-importetd-cat-ids-'.$feedId.'.tmp';
		$fp = fopen($filename, "w");
		$ids_in_yml = serialize($find_cat_arr);
		fwrite($fp, $ids_in_yml);
		fclose($fp);
		if ($ipytw_when_import_category === 'once') { 
			ipytw_optionUPD('ipytw_when_import_category', 'disabled', $feedId, 'yes', 'set_arr');
		}
	} else {
		error_log('ERROR: ipytw_feed_header: Нет папки import-from-yml! $name_dir ='.$name_dir.'; Файл: offer.php; Строка: '.__LINE__, 0);
		return false;
	}
 } else {
	ipytw_error_log('NOTICE: $ipytw_when_import_category = '.$ipytw_when_import_category.'. Категории обновлять не нужно; Файл: offer.php; Строка: '.__LINE__, 0);	
 }

 ipytw_error_log('FEED № '.$feedId.'; Отработала ipytw_feed_header; Файл: offer.php; Строка: '.__LINE__, 0);
 return true;
}
function ipytw_unit($offer_xml_object, $feed_imported_cat_arr, $feedId, $feed_imported_offers_arr = array()) {	
 // https://skosta.ru/wordpress/woocommerce/
 // https://www.php.net/manual/ru/class.simplexmlelement.php
 // https://wp-kama.ru/plugin/woocommerce/function/WC_Product
 // http://wpcommerce.ru/threads/kak-programmno-dobavit-variaciju-k-tovaru.5919/
 ipytw_error_log('FEED № '.$feedId.'; Стартовала ipytw_unit; Файл: offer.php; Строка: '.__LINE__, 0);
 $stop_flag = false;
 $xml_offer_attr_object = $offer_xml_object->attributes();
 if ($xml_offer_attr_object->group_id === null) {
 	$feed_product_id = (string)$xml_offer_attr_object->id;
 } else {
	ipytw_error_log('NOTICE: Пропускаем вариативный товар; Файл: offer.php; Строка: '.__LINE__, 0);
	return false;
 }
 ipytw_error_log('INFO: Проверяем товар. Его id в фиде $feed_product_id = '.$feed_product_id.'; Файл: offer.php; Строка: '.__LINE__, 0);

 $stop_flag = apply_filters('ipytw_stop_flag_filter', $stop_flag, array('offer_xml_object' => $offer_xml_object, 'feed_imported_cat_arr' => $feed_imported_cat_arr), $feedId);
 if ($stop_flag === true) {
	ipytw_error_log('NOTICE: Пропускаем товар $feed_product_id = '.$feed_product_id.' по флагу; Файл: offer.php; Строка: '.__LINE__, 0);
	return false;
 }

 $ipytw_source_sku = ipytw_optionGET('ipytw_source_sku', $feedId, 'set_arr'); 
 switch ($ipytw_source_sku) {
	case 'vendor_code':
		$product_sku = (string)$offer_xml_object->vendorCode;
	break;
	case 'shop_sku':
		$el_name = 'shop-sku';
		$product_sku = (string)$offer_xml_object->$el_name;
	break;
	case 'sku':
		$product_sku = (string)$offer_xml_object->sku;		
	break;
	case 'article':
		$product_sku = (string)$offer_xml_object->article;		
	break;
	case 'product_id':
		$product_sku = (string)$feed_product_id;
	break;
	default:
		$product_sku = false;
		do_action('ipytw_switch_source_check_sku_action', $offer_xml_object, $feedId); 
 }
 // проверяем, существует ли товар с таким артикулом
 if (ipytw_is_uniq_sku($product_sku) === true) {
	ipytw_error_log('FEED № '.$feedId.'; Товар с артикулом $product_sku = '.$product_sku.' уже существует; Файл: offer.php; Строка: '.__LINE__, 0);
	$ipytw_if_isset_sku = ipytw_optionGET('ipytw_if_isset_sku', $feedId, 'set_arr');
	if ($ipytw_if_isset_sku === 'disabled' || $ipytw_if_isset_sku === '') {
		ipytw_error_log('FEED № '.$feedId.'; WARNING: Товар пропущен по причине дублирующегося артикула; Файл: offer.php; Строка: '.__LINE__, 0);
		return false;
	}
	if ($ipytw_if_isset_sku === 'update') {
		$check_sync_product = (int)wc_get_product_id_by_sku($product_sku);
	} else {
		$check_sync_product = ipytw_check_sync($feed_product_id, $feedId, 'product');
	}
 } else {
 	$check_sync_product = ipytw_check_sync($feed_product_id, $feedId, 'product');
 }
 if ($check_sync_product === false) {
	ipytw_error_log('FEED № '.$feedId.'; Товар ранее не был импортирован; Файл: offer.php; Строка: '.__LINE__, 0);
	$args = array(
		'feed_product_id' => $feed_product_id,
		'offer_xml_object' => $offer_xml_object,
		'feed_imported_cat_arr' => $feed_imported_cat_arr,
	);
	$res = ipytw_product_add($args, $feedId);
 } else {
	$site_product_id = (int)$check_sync_product;
	ipytw_error_log('FEED № '.$feedId.'; Товар ранее был импортирован. $site_product_id = '.$site_product_id.'; Файл: offer.php; Строка: '.__LINE__, 0);
	$args = array(
		'feed_product_id' => $feed_product_id,
		'offer_xml_object' => $offer_xml_object,
		'feed_imported_cat_arr' => $feed_imported_cat_arr,
		'site_product_id' => $site_product_id,
		'ipytw_product_was_sync' => ipytw_optionGET('ipytw_product_was_sync', $feedId, 'set_arr')
	);
	$res = ipytw_product_upd($args, $feedId);
 }
 if ($res === false) {
	return false;
 } else {
 	return $res;
 }
} // end function ipytw_unit($postId) {
?>